<template>
  <div id="app">
    <Header />
    <router-view />
    <Footer />
    <CookiePolicy />
    <UtilityDefault
      googleMaps
    />
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

import Header from '@header/header.vue'
import Footer from '@footer/footer.vue'
import CookiePolicy from '@molecules/cookie-policy/default/cookie-policy-default.vue'
import UtilityDefault from '@atoms/utility/default/utility-default.vue'

export default Vue.extend({
  components: {
    Header,
    Footer,
    CookiePolicy,
    UtilityDefault
  },
  data() {
    return {
    }
  },
  async mounted() {
    // Map key script
    // eslint-disable-next-line no-useless-escape
    this.$genericHelpers.loadScript(document.head, `<script src="https://maps.googleapis.com/maps/api/js?key=${await this.getMapKey()}"><\/script>`)

    /* once app is ready reveal content (SSR needed) */
    const s = document.getElementsByClassName('removeMe')[0]
    if (s !== undefined) {
      s.remove()
    }
  },
  methods: {
    async getMapKey() {
      if (process.env.NODE_ENV === 'development') {
        return 'AIzaSyBLIOmL8c5CYqlaIS4F7NXGTEKuYG2Z_e0'
      }

      return await this.$rs.settings.lift('google_maps_api_key')
    }
  }
})
</script>

<style lang="scss">
#app {
  font-family: $body-font;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: $body;
}
</style>
